-- Suppression des tables
DROP TABLE COURS;
DROP TABLE TUE;
DROP TABLE ETUDIANT;

-- Suppression des types complexe
DROP TYPE Etudiant_Type;
DROP TYPE PrenomType;
DROP TYPE TABLECOURSTYPE;
DROP TYPE Type_Cours;
DROP TYPE Type_UE;

-- Création d'une table UE pour les unités d'enseignement
CREATE OR REPLACE TYPE Type_UE AS OBJECT (
     id NUMBER,
     isOption NUMBER(1),
     nom VARCHAR2(30)
);

-- CREATE TABLE TUE OF UE;
CREATE TABLE TUE OF Type_UE(
    CONSTRAINT PK_TUE PRIMARY KEY(id),
    CONSTRAINT check_isOption CHECK (isOPtion BETWEEN 0 AND 1)
);

CREATE OR REPLACE TYPE Type_Cours AS OBJECT (
    id NUMBER,
    jour VARCHAR2(15),
    creneau NUMBER(3),
    numGroupe NUMBER(3),
    typeCours VARCHAR2(2),
    UE REF Type_UE
);

CREATE TABLE Cours OF Type_Cours(
   CONSTRAINT PK_COURS PRIMARY KEY(id)
);

-- Création d'un type pour la liste des prénoms
CREATE OR REPLACE TYPE PrenomType AS TABLE OF VARCHAR2(50);
CREATE OR REPLACE TYPE TableCoursType AS TABLE OF REF Type_Cours;

-- Création du type Etudiant avec une table emboitée pour les prénoms
CREATE OR REPLACE TYPE Etudiant_Type AS OBJECT (
    identifiant NUMBER(8),
    nom VARCHAR2(100),
    prenoms PrenomType,
    coursInscrits TableCoursType
);

-- Création d'une table Etudiants pour les objets etudiants
CREATE TABLE Etudiant OF Etudiant_Type(
    CONSTRAINT PK_ETUDIANT PRIMARY KEY(identifiant)
)
NESTED TABLE prenoms STORE AS TablePrenoms,
NESTED TABLE coursInscrits STORE AS TableTypeCours;


-- Exemple d'insertion d'un etudiant avec plusieurs prénoms
INSERT INTO TUE VALUES (Type_UE(1, 1,'Programmation'));
INSERT INTO TUE VALUES (Type_UE(2, 0,'Algebre'));
INSERT INTO TUE VALUES (Type_UE(3, 0,'Astrophysique'));
INSERT INTO TUE VALUES (Type_UE(4, 1,'Linux'));
INSERT INTO TUE VALUES (Type_UE(5, 1,'NSI'));
INSERT INTO TUE VALUES (Type_UE(6, 0,'Remediation'));
INSERT INTO TUE VALUES (Type_UE(7, 0,'Concepts informatiques'));
INSERT INTO TUE VALUES (Type_UE(8, 0,'Anglais'));
INSERT INTO TUE VALUES (Type_UE(9, 1,'Analyse'));

SELECT * FROM TUE;

INSERT INTO Cours VALUES (Type_Cours(1, 'Lundi', 1, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));
INSERT INTO Cours VALUES (Type_Cours(2, 'Lundi', 2, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Algebre')));
INSERT INTO Cours VALUES (Type_Cours(3, 'Lundi', 2, 2, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Algebre')));
INSERT INTO Cours VALUES (Type_Cours(4, 'Lundi', 3, 0, 'CM', (SELECT REF(e) FROM TUE e WHERE e.nom='Astrophysique')));
INSERT INTO Cours VALUES (Type_Cours(5, 'Lundi', 3, 1, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(6, 'Lundi', 3, 2, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='NSI')));
INSERT INTO Cours VALUES (Type_Cours(7, 'Lundi', 3, 3, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));
INSERT INTO Cours VALUES (Type_Cours(8, 'Lundi', 4, 1, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='NSI')));
INSERT INTO Cours VALUES (Type_Cours(9, 'Lundi', 4, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Remediation')));
INSERT INTO Cours VALUES (Type_Cours(10, 'Lundi', 4, 2, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Concepts informatiques')));


INSERT INTO Cours VALUES (Type_Cours(11, 'Mardi', 1, 0, 'CM', (SELECT REF(e) FROM TUE e WHERE e.nom='Astrophysique')));
INSERT INTO Cours VALUES (Type_Cours(12, 'Mardi', 1, 1, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Concepts informatiques')));
INSERT INTO Cours VALUES (Type_Cours(13, 'Mardi', 1, 2, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));
INSERT INTO Cours VALUES (Type_Cours(14, 'Mardi', 1, 4, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(15, 'Mardi', 3, 2, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Anglais')));
INSERT INTO Cours VALUES (Type_Cours(16, 'Mardi', 4, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Remediation')));
INSERT INTO Cours VALUES (Type_Cours(17, 'Mardi', 4, 3, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(18, 'Mardi', 4, 4, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));


INSERT INTO Cours VALUES (Type_Cours(19, 'Mercredi', 1, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Anglais')));
INSERT INTO Cours VALUES (Type_Cours(20, 'Mercredi', 1, 4, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(21, 'Mercredi', 2, 1, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));
INSERT INTO Cours VALUES (Type_Cours(22, 'Mercredi', 2, 1, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(23, 'Mercredi', 2, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Algebre')));
INSERT INTO Cours VALUES (Type_Cours(24, 'Mercredi', 3, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Algebre')));
INSERT INTO Cours VALUES (Type_Cours(25, 'Mercredi', 3, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Analyse')));
INSERT INTO Cours VALUES (Type_Cours(26, 'Mercredi', 3, 3, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));
INSERT INTO Cours VALUES (Type_Cours(27, 'Mercredi', 4, 0, 'CM', (SELECT REF(e) FROM TUE e WHERE e.nom='Concepts informatiques')));


INSERT INTO Cours VALUES (Type_Cours(28, 'Jeudi', 1, 1, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='NSI')));
INSERT INTO Cours VALUES (Type_Cours(29, 'Jeudi', 1, 2, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(30, 'Jeudi', 2, 2, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));
INSERT INTO Cours VALUES (Type_Cours(31, 'Jeudi', 2, 3, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(32, 'Jeudi', 2, 4, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Programmation')));


INSERT INTO Cours VALUES (Type_Cours(33, 'Vendredi', 1, 1, 'CM', (SELECT REF(e) FROM TUE e WHERE e.nom='Concepts informatiques')));
INSERT INTO Cours VALUES (Type_Cours(34, 'Vendredi', 1, 2, 'CM', (SELECT REF(e) FROM TUE e WHERE e.nom='Concepts informatiques')));
INSERT INTO Cours VALUES (Type_Cours(35, 'Vendredi', 2, 1, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='Linux')));
INSERT INTO Cours VALUES (Type_Cours(36, 'Vendredi', 2, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Analyse')));
INSERT INTO Cours VALUES (Type_Cours(37, 'Vendredi', 2, 2, 'TP', (SELECT REF(e) FROM TUE e WHERE e.nom='NSI')));
INSERT INTO Cours VALUES (Type_Cours(38, 'Vendredi', 3, 1, 'TD', (SELECT REF(e) FROM TUE e WHERE e.nom='Remediation')));

SELECT id, creneau, numgroupe, typecours,
       (SELECT DEREF(cour.UE).nom AS ue_nom FROM Cours cour WHERE cour.jour = 'Lundi' AND cour.typecours = 'TD' AND cour.creneau = 1) AS UE FROM COURS;

/*
identifiant NUMBER(8),
nom VARCHAR2(100),
prenoms PrenomType,
coursInscrits TableCoursType
 */


INSERT INTO ETUDIANT VALUES (
    Etudiant_Type(2024001, 'DEZETREE', PrenomType('Jérémy', 'Pascal', 'Alexis'),
                  TableCoursType(
                          (SELECT REF(c) FROM Cours c WHERE c.jour = 'Lundi' AND c.creneau = 1 AND c.typecours = 'TD' AND c.numgroupe = 1),
                          (SELECT REF(c) FROM Cours c WHERE c.jour = 'Mardi' AND c.creneau = 1 AND c.typecours = 'TP' AND c.numgroupe = 2)
)));

SELECT * FROM ETUDIANT;

SELECT e.nom, e.prenoms, c.*
FROM Etudiant e,
     TABLE(DEREF(e.coursInscrits)) c
WHERE c.typeCours = 'TD';

-- Requête pour afficher les données
SELECT e.id, e.nom, p.*, e.dob
FROM Etudiant e, TABLE(e.prenoms) p;

SELECT * FROM Etudiant;

SELECT * FROM TUE;